#!/usr/bin/perl
#
# Licensed Materials - Property of IBM
#
# 5698-FRA
#
# (C) Copyright IBM Corp. 2003,2005 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp
#

open(LOG, ">>epwebpost.log");
print "Content-type: text/plain\n\n";
read(STDIN,$temp,$ENV{'CONTENT_LENGTH'});
print LOG "=================[ENDPOINT HEALTH]=====================\n";
print LOG "Content-length:$ENV{'CONTENT_LENGTH'}\n";
print LOG "Remote-addr:$ENV{'REMOTE_ADDR'}\n";
print LOG "Remote-port:$ENV{'REMOTE_PORT'}\n";
@pairs=split(/&/,$temp);
foreach $item(@pairs) {
	($key, $content)=split(/=/,$item,2);
	$content=~tr/+/ /;
	$content=~s/%(..)/pack("c",hex($1))/ge;
	$fields{$key}=$content;
	print "${key}=${content}\n";
	print LOG "${key}=${content}\n";
	if (${key} eq "events") {
		@errorlist = split(/:/, ${content});
		foreach $ekey (@errorlist) {
			if ($ekey eq "01") {
				print LOG "STATECHANGE: LCFD process on this system has been SHUTDOWN.\n";
			}
			elsif ($ekey eq "02") {
				print LOG "STATECHANGE: LCFD process on this system entered STANDBY mode.\n";
			}
			elsif ($ekey eq "03") {
				print LOG "STATECHANGE: LCFD process on this system has RESUMED operation.\n";
			}
			elsif ($ekey eq "04") {
				print LOG "STATECHANGE: LCFD successfully started its IPC server.\n";
			}
			elsif ($ekey eq "05") {
				print LOG "STATECHANGE: LCFD shut down its IPC server.\n";
			}
			elsif ($ekey eq "06") {
				print LOG "STATECHANGE: LCFD detected a change in the local network configuration.\n";
			}
			elsif ($ekey eq "07") {
				print LOG "STATECHANGE: LCFD process on this system has been STARTED.\n";
			}
			elsif ($ekey eq "10") {
				print LOG "LOGIN: LCFD has successfully logged in to a gateway and is running OK.\n";
			}
			elsif ($ekey eq "11") {
				print LOG "LOGIN: LCFD login attempt failed. The gateway is\n";
				print LOG "     : unreachable, down, or is not available.\n";
				print LOG "     : Please check to make sure that the gateway is up and running.\n";
			}
			elsif ($ekey eq "12") {
				print LOG "LOGIN: LCFD is logging in to a new gateway as the result of a migration.\n";
			}
			elsif ($ekey eq "13") {
				print LOG "LOGIN: LCFD has been redirected to another TMR.\n";
			}
			elsif ($ekey eq "20") {
				print LOG "UPCALL: LCFD upcall to gateway failed to complete because the gateway\n";
				print LOG "      : failed to respond or is unreachable.\n"
			}
			elsif ($ekey eq "21") {
				print LOG "UPCALL: Warning, method execution was performed without a valid\n";
				print LOG "      : user ID or credential.\n";
			}
			elsif ($ekey eq "30") {
				print LOG "RUNIMPL: Method failed to complete because the LCFD was unable to\n";
				print LOG "       : find or execute the method implementation.\n";
			}
			elsif ($ekey eq "31") {
				print LOG "RUNIMPL: Downcall failed to complete because the method threw\n";
				print LOG "       : an exception before execution could complete.\n";
			}
			elsif ($ekey eq "35") {
				print LOG "RUNTEST: Unable to generate a token for the built-in Administrator.\n";
			}
			elsif ($ekey eq "36") {
				print LOG "RUNTEST: Unable to generate a token for the tmersrvd account.\n";
			}
			elsif ($ekey eq "37") {
				print LOG "RUNTEST: Unable to spawn test process for endpoint self-check.\n";
			}
			elsif ($ekey eq "40") {
				print LOG "RUNTASK: No appropriate executable defined for this INTERP.\n";
			}
			elsif ($ekey eq "41") {
				print LOG "RUNTASK: Failed to create task file on endpoint.\n";
			}
			elsif ($ekey eq "42") {
				print LOG "RUNTASK: Failed to set required permission on temporary file.\n";
			}
			elsif ($ekey eq "43") {
				print LOG "RUNTASK: Error configuring required I/O streams.\n";
			}
			elsif ($ekey eq "44") {
				print LOG "RUNTASK: Failed to get user token for task.\n";
			}
			elsif ($ekey eq "45") {
				print LOG "RUNTASK: Failed to execute task.\n";
			}
			elsif ($ekey eq "50") {
				print LOG "TAPCALL: Tivoli Authentication Package initialization failed.\n";
			}
			elsif ($ekey eq "51") {
				print LOG "TAPCALL: Failed to initialize Tivoli Authentication Package token pool.\n";
			}
			elsif ($ekey eq "52") {
				print LOG "TAPCALL: Tivoli Authentication Package token cache has expired.\n"; 
			}
			elsif ($ekey eq "53") {
				print LOG "TAPCALL: Tivoli Authentication Package account name lookup failed.\n";
			}
			elsif ($ekey eq "60") {
				print LOG "HMAC: Endpoint received data that could not be decrypted.\n";
			}
			elsif ($ekey eq "65") {
				print LOG "RUNCMD: Error spawning intrinsic command.\n";
			}
			elsif ($ekey eq "66") {
				print LOG "RUNCMD: Error redirecting input or output for intrinsic command.\n";
			}
			elsif ($ekey eq "67") {
				print LOG "RUNCMD: Error waiting for intrinsic command to terminate.\n";
			}
			elsif ($ekey eq "68") {
				print LOG "RUNCMD: Error retrieving exit code from intrinsic command.\n";
			}
			elsif ($ekey eq "70") {
				print LOG "REPAIR: Error creating or writing file(s) in TEMP directory.\n";
			}
			elsif ($ekey eq "71") {
				print LOG "REPAIR: Requested amount of TEMP space is not available.\n";
			}
			elsif ($ekey eq "72") {
				print LOG "REPAIR: Error creating or writing file(s) in CACHE directory.\n";
			}
			elsif ($ekey eq "73") {
				print LOG "REPAIR: Requested amount of CACHE space is not available.\n";
			}
			elsif ($ekey eq "74") {
				print LOG "REPAIR: The Tivoli Authentication Package is not installed.\n";
			}
			elsif ($ekey eq "75") {
				print LOG "REPAIR: A reboot is required to activate the Tivoli Authentication Package.\n";
			}
			elsif ($ekey eq "76") {
				print LOG "REPAIR: The tmersrvd account does not exist (or is misconfigured).\n";
			}
			elsif ($ekey eq "77") {
				print LOG "REPAIR: The Tivoli_Admin_Privileges group does not exist (or is misconfigured).\n";
			}
			elsif ($ekey eq "78") {
				print LOG "REPAIR: The tmersrvd account does not have permission to read files in System32.\n";
			}
			elsif ($ekey eq "79") {
				print LOG "REPAIR: The lcfd service is not set to autostart.\n";
			}
			elsif ($ekey eq "80") {
				print LOG "REPAIR: The lcfd service recovery configuration does not match endpoint parameters.\n";
			}
			else {
				print LOG "UNKNOWN: Unrecognized code found in log: $ekey.\n";
			}
		}
	}
}
close(LOG);

